cryptonite-0.23: Cryptography Primitives sink

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | Good
Safe Haskell | None
Language | Haskell2010

Crypto.PubKey.DH

Description

Synopsis

- data Params = Params {
  - params_p :: Integer
  - params_g :: Integer
  - params_bits :: Int
  }
- newtype PublicNumber = PublicNumber Integer
- newtype PrivateNumber = PrivateNumber Integer
- newtype SharedKey = SharedKey ScrubbedBytes
- generateParams :: MonadRandom m => Int -> Integer -> m Params
- generatePrivate :: MonadRandom m => Params -> m PrivateNumber
- calculatePublic :: Params -> PrivateNumber -> PublicNumber
- generatePublic :: Params -> PrivateNumber -> PublicNumber
- getShared :: Params -> PrivateNumber -> PublicNumber -> SharedKey

# Documentation

data Params Source #

Represent Diffie Hellman parameters namely P (prime), and G (generator).

Constructors

Params |

Fields

- params_p :: Integer
- params_g :: Integer
- params_bits :: Int

Instances

Eq Params Source # |
Methods (==) :: Params -> Params -> Bool # (/=) :: Params -> Params -> Bool #
Data Params Source # |

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Params -> c Params #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Params #

toConstr :: Params -> Constr #

dataTypeOf :: Params -> DataType #

dataCast1 :: Typeable (* -> *) t => (forall d. Data d => c (t d)) -> Maybe (c Params) #

dataCast2 :: Typeable (* -> * -> *) t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Params) #

gmapT :: (forall b. Data b => b -> b) -> Params -> Params #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Params -> r #

gmapQr :: (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Params -> r #

gmapQ :: (forall d. Data d => d -> u) -> Params -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Params -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Params -> m Params #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Params -> m Params #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Params -> m Params #

Read Params Source # |
Methods readsPrec :: Int -> ReadS Params # readList :: ReadS [Params] # readPrec :: ReadPrec Params # readListPrec :: ReadPrec [Params] #
Show Params Source # |
Methods showsPrec :: Int -> Params -> ShowS # show :: Params -> String # showList :: [Params] -> ShowS #

newtype PublicNumber Source #

Represent Diffie Hellman public number Y.

Constructors

PublicNumber Integer |

Instances

Enum PublicNumber Source # |

Methods

succ :: PublicNumber -> PublicNumber #

pred :: PublicNumber -> PublicNumber #

toEnum :: Int -> PublicNumber #

fromEnum :: PublicNumber -> Int #

enumFrom :: PublicNumber -> [PublicNumber] #

enumFromThen :: PublicNumber -> PublicNumber -> [PublicNumber] #

enumFromTo :: PublicNumber -> PublicNumber -> [PublicNumber] #

enumFromThenTo :: PublicNumber -> PublicNumber -> PublicNumber -> [PublicNumber] #

Eq PublicNumber Source # |
Methods (==) :: PublicNumber -> PublicNumber -> Bool # (/=) :: PublicNumber -> PublicNumber -> Bool #
Num PublicNumber Source # |
Methods (+) :: PublicNumber -> PublicNumber -> PublicNumber # (-) :: PublicNumber -> PublicNumber -> PublicNumber # (*) :: PublicNumber -> PublicNumber -> PublicNumber # negate :: PublicNumber -> PublicNumber # abs :: PublicNumber -> PublicNumber # signum :: PublicNumber -> PublicNumber # fromInteger :: Integer -> PublicNumber #
Ord PublicNumber Source # |
Methods compare :: PublicNumber -> PublicNumber -> Ordering # (<) :: PublicNumber -> PublicNumber -> Bool # (<=) :: PublicNumber -> PublicNumber -> Bool # (>) :: PublicNumber -> PublicNumber -> Bool # (>=) :: PublicNumber -> PublicNumber -> Bool # max :: PublicNumber -> PublicNumber -> PublicNumber # min :: PublicNumber -> PublicNumber -> PublicNumber #
Read PublicNumber Source # |
Methods readsPrec :: Int -> ReadS PublicNumber # readList :: ReadS [PublicNumber] # readPrec :: ReadPrec PublicNumber # readListPrec :: ReadPrec [PublicNumber] #
Real PublicNumber Source # |
Methods toRational :: PublicNumber -> Rational #
Show PublicNumber Source # |
Methods showsPrec :: Int -> PublicNumber -> ShowS # show :: PublicNumber -> String # showList :: [PublicNumber] -> ShowS #

newtype PrivateNumber Source #

Represent Diffie Hellman private number X.

Constructors

PrivateNumber Integer |

Instances

Enum PrivateNumber Source # |

Methods

succ :: PrivateNumber -> PrivateNumber #

pred :: PrivateNumber -> PrivateNumber #

toEnum :: Int -> PrivateNumber #

fromEnum :: PrivateNumber -> Int #

enumFrom :: PrivateNumber -> [PrivateNumber] #

enumFromThen :: PrivateNumber -> PrivateNumber -> [PrivateNumber] #

enumFromTo :: PrivateNumber -> PrivateNumber -> [PrivateNumber] #

enumFromThenTo :: PrivateNumber -> PrivateNumber -> PrivateNumber -> [PrivateNumber] #

Eq PrivateNumber Source # |
Methods (==) :: PrivateNumber -> PrivateNumber -> Bool # (/=) :: PrivateNumber -> PrivateNumber -> Bool #
Num PrivateNumber Source # |
Methods (+) :: PrivateNumber -> PrivateNumber -> PrivateNumber # (-) :: PrivateNumber -> PrivateNumber -> PrivateNumber # (*) :: PrivateNumber -> PrivateNumber -> PrivateNumber # negate :: PrivateNumber -> PrivateNumber # abs :: PrivateNumber -> PrivateNumber # signum :: PrivateNumber -> PrivateNumber # fromInteger :: Integer -> PrivateNumber #
Ord PrivateNumber Source # |
Methods compare :: PrivateNumber -> PrivateNumber -> Ordering # (<) :: PrivateNumber -> PrivateNumber -> Bool # (<=) :: PrivateNumber -> PrivateNumber -> Bool # (>) :: PrivateNumber -> PrivateNumber -> Bool # (>=) :: PrivateNumber -> PrivateNumber -> Bool # max :: PrivateNumber -> PrivateNumber -> PrivateNumber # min :: PrivateNumber -> PrivateNumber -> PrivateNumber #
Read PrivateNumber Source # |
Methods readsPrec :: Int -> ReadS PrivateNumber # readList :: ReadS [PrivateNumber] # readPrec :: ReadPrec PrivateNumber # readListPrec :: ReadPrec [PrivateNumber] #
Real PrivateNumber Source # |
Methods toRational :: PrivateNumber -> Rational #
Show PrivateNumber Source # |
Methods showsPrec :: Int -> PrivateNumber -> ShowS # show :: PrivateNumber -> String # showList :: [PrivateNumber] -> ShowS #

newtype SharedKey Source #

Represent Diffie Hellman shared secret.

Constructors

SharedKey ScrubbedBytes |

Instances

Eq SharedKey Source # |
Methods (==) :: SharedKey -> SharedKey -> Bool # (/=) :: SharedKey -> SharedKey -> Bool #
Show SharedKey Source # |
Methods showsPrec :: Int -> SharedKey -> ShowS # show :: SharedKey -> String # showList :: [SharedKey] -> ShowS #
ByteArrayAccess SharedKey Source # |
Methods length :: SharedKey -> Int # withByteArray :: SharedKey -> (Ptr p -> IO a) -> IO a #

generateParams Source #

Arguments

:: MonadRandom m |
=> Int | number of bits
-> Integer | generator
-> m Params |

generate params from a specific generator (2 or 5 are common values) we generate a safe prime (a prime number of the form 2p+1 where p is also prime)

generatePrivate :: MonadRandom m => Params -> m PrivateNumber Source #

generate a private number with no specific property this number is usually called X in DH text.

calculatePublic :: Params -> PrivateNumber -> PublicNumber Source #

calculate the public number from the parameters and the private key this number is usually called Y in DH text.

generatePublic :: Params -> PrivateNumber -> PublicNumber Source #

calculate the public number from the parameters and the private key this number is usually called Y in DH text.

DEPRECATED use calculatePublic

getShared :: Params -> PrivateNumber -> PublicNumber -> SharedKey Source #

generate a shared key using our private number and the other party public number